<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    label: {
      type: String,
      required: false,
      default: null,
    },
    options: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
    placeholder: {
      type: String,
      required: false,
      default: 'Jump to a section',
    },
    fixed: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  methods: {
    navigateToAnchor(event: any) {
      const hash = event.target.value;
      this.$router.push({ hash });
    },
  },
});
</script>

<template>
  <div class="dropdown__container" :class="{ fixed }">
    <label v-if="label" class="dropdown__label"> {{ label }} </label>
    <div class="chevron-wrapper">
      <SlpTypography variant="body1">
        <select @change="navigateToAnchor">
          <option value="">{{ placeholder }}</option>
          <option
            v-for="item in options"
            :key="item.text"
            :value="item.id_tag || item.href"
          >
            {{ item.text }}
          </option>
        </select>
      </SlpTypography>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.fixed {
  position: -webkit-sticky;
  position: sticky;
  left: 0;
  right: 0;
  top: 80px;
  z-index: 100;
  padding: $spacing-8;
  transition: all 0.3s ease;

  @media (max-width: 575px) {
    top: 110px;
  }
}

.chevron-wrapper {
  position: relative;
  width: 100%;
  &::after {
    content: url('/nuxt-images/icons/dropdown-chevron.svg');
    font-size: 1rem;
    top: 10px;
    right: 16px;
    position: absolute;
    pointer-events: none;
  }
}

.dropdown {
  &__container {
    background: white;
    width: 100%;
    display: none;
    margin-bottom: $spacing-24;

    @media (max-width: $breakpoint-md) {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
    }
  }
  &__label {
    align-self: flex-start;
    font-size: 10px;
    line-height: 20px;
    margin-bottom: 5px;
    text-transform: uppercase;
  }
}
select {
  background: #fff;
  border: 1px solid #333;
  height: 48px;
  border-radius: 4px;
  width: 100%;
  outline: none;
  padding: 11px;
  -webkit-appearance: none;
  appearance: none;
}
</style>
